WILDMAT(3)             C LIBRARY FUNCTIONS             WILDMAT(3)

NAME
     wildmat - perform shell-style wildcard matching

SYNOPSIS
     int
     wildmat(text, pattern)
         char       *text;
         char       *pattern;

DESCRIPTION
     Wildmat compares the text against the  pattern  and  returns
     non-zero  if  the  pattern matches the text.  The pattern is
     interpreted similar to shell filename wildcards, and not  as
     a  full  regular  expression  such  as  those handled by the
     grep(1) family of programs or the regex(3) or regexp(3)  set
     of routines.

     The pattern is interpreted according to the following rules:

     \x   Turns off the special  meaning  of  x  and  matches  it
          directly; this is used mostly before a question mark or
          asterisk, and is not valid inside square brackets.

     ?    Matches any single character.

     *    Matches any sequence of zero or more characters.

     [x...y]
          Matches any  single  character  specified  by  the  set
          x...y,  where  any  character  other than minus sign or
          close bracket may appear in the set.  A minus sign  may
          be  used  to  indicate a range of characters.  That is,
          [0-5abc] is a shorthand for [012345abc].  More than one
          range  may appear inside a character set; [0-9a-zA-Z._]
          matches almost all of the legal characters for  a  host
          name.

     [^x...y]
          This matches any character not in the set x...y,  which
          is interpreted as described above.

BUGS
     There is no way to specify  a  minus  sign  in  a  character
     range.

HISTORY
     Written by Rich $alz <rsalz@bbn.com> in 1986, and posted  to
     Usenet   several   times   since   then,   most  notably  in
     comp.sources.misc in March, 1991.

     Lars Mathiesen <thorinn@diku.dk> enhanced the multi-asterisk
     failure mode in early 1991.



WILDMAT(3)             C LIBRARY FUNCTIONS             WILDMAT(3)

     Rich and Lars increased the efficiency of star patterns  and
     reposted it to comp.sources.misc in April, 1991.

     This is revision 1.4, dated 91/03/25.

SEE ALSO
     grep(1), regex(3), regexp(3).
