(*****************************************************************************)
(**)                                                                       (**)
(**)            program datum_zeit;           (* Version 1.1 *)            (**)
(**)                                                                       (**)
(*****************************************************************************)

(*****************************************************************************)
(* Entwickelt mit ST PASCAL PLUS von CCD.                                    *)
(* Natrlich frei kopierbar.                                                 *)
(* Datum : 8. Februar 1987                                                   *)
(* Autor : Dietmar Rabich, Eschenweg 3, 4408 Dlmen                          *)
(*****************************************************************************)

(*****************************************************************************)
(******************************* DEKLARATIONEN *******************************)
(**)                                                                       (**)
(**) var std,min,sek,tag,mon,jahr : integer;                               (**)
(**)                                                                       (**)
(*****************************************************************************)
(*****************************************************************************)

(*****************************************************************************)
(******************************* SYSTEMAUFRUFE *******************************)
(**)                                                                       (**)
(**) function getdate:integer;            GEMDOS($2A);                     (**)
(**)                                                                       (**)
(**) procedure setdate(d:integer);        GEMDOS($2B);                     (**)
(**)                                                                       (**)
(**) function gettime:integer;            GEMDOS($2C);                     (**)
(**)                                                                       (**)
(**) procedure settime(z:integer);        GEMDOS($2D);                     (**)
(**)                                                                       (**)
(**) function conin(dev:integer):integer; BIOS(2);                         (**)
(**)                                                                       (**)
(*****************************************************************************)
(*****************************************************************************)

(*****************************************************************************)
(*************************** BILDSCHIRMEINSTELLUNG ***************************)
(**)                                                                       (**)
(**) procedure bildschirm_einstellung;                                     (**)
(**)                                                                       (**)
(**)  procedure clear_home;                                                (**)
(**)                                                                       (**)
(**)   begin                                                               (**)
(**)    write (chr (27), 'E');                                             (**)
(**)   end;                                                                (**)
(**)                                                                       (**)
(**)  procedure select_color (color: integer);                             (**)
(**)                                                                       (**)
(**)   begin                                                               (**)
(**)    write (chr (27), 'b', chr (ord ('0') + color & $F));               (**)
(**)   end;                                                                (**)
(**)                                                                       (**)
(**)  procedure select_background (color: integer);                        (**)
(**)                                                                       (**)
(**)   begin                                                               (**)
(**)    write (chr (27), 'c', chr (ord ('0') + color & $F));               (**)
(**)   end;                                                                (**)
(**)                                                                       (**)
(**)  procedure wrap_on;                                                   (**)
(**)                                                                       (**)
(**)   begin                                                               (**)
(**)    write (chr (27), 'v');                                             (**)
(**)   end;                                                                (**)
(**)                                                                       (**)
(**) begin                                                                 (**)
(**)  select_color(0);                                                     (**)
(**)  select_background(1);                                                (**)
(**)  wrap_on;                                                             (**)
(**)  clear_home;                                                          (**)
(**) end;                                                                  (**)
(**)                                                                       (**)
(*****************************************************************************)
(*****************************************************************************)

(*****************************************************************************)
(*************************** ZEIT UND DATUM HOLEN ****************************)
(**)                                                                       (**)
(**) procedure hole_zeit_und_datum (var h,m,s,t,mo,j : integer);           (**)
(**)                                                                       (**)
(**)  var zeit,datum : integer;                                            (**)
(**)                                                                       (**)
(**) begin                                                                 (**)
(**)  zeit:=gettime;                                                       (**)
(**)  s:=zeit-shl(shr(zeit,5),5);                                          (**)
(**)  zeit:=shr((zeit-s),5);                                               (**)
(**)  m:=zeit-shl(shr(zeit,6),6);                                          (**)
(**)  h:=shr(zeit,6);                                                      (**)
(**)  s:=s*2;                                                              (**)
(**)  datum:=getdate;                                                      (**)
(**)  t:=datum-shl(shr(datum,5),5);                                        (**)
(**)  datum:=shr((datum-t),5);                                             (**)
(**)  mo:=datum-shl(shr(datum,4),4);                                       (**)
(**)  j:=shr(datum,4);                                                     (**)
(**) end;                                                                  (**)
(**)                                                                       (**)
(*****************************************************************************)
(*****************************************************************************)

(*****************************************************************************)
(*************************** ZEIT UND DATUM SETZEN ***************************)
(**)                                                                       (**)
(**) procedure setze_zeit_und_datum (h,m,t,mo,j : integer);                (**)
(**)                                                                       (**)
(**)  var zeit,datum : integer;                                            (**)
(**)                                                                       (**)
(**) begin                                                                 (**)
(**)  zeit:=shl(h,11)+shl(m,5);                                            (**)
(**)  settime(zeit);                                                       (**)
(**)  datum:=shl(j-1980,9)+shl(mo,5)+t;                                    (**)
(**)  setdate(datum);                                                      (**)
(**) end;                                                                  (**)
(**)                                                                       (**)
(*****************************************************************************)
(*****************************************************************************)

(*****************************************************************************)
(******************************* HAUPTPROGRAMM *******************************)
(**)                                                                       (**)
(**) begin                                                                 (**)
(**)  bildschirm_einstellung;                                              (**)
(**)  hole_zeit_und_datum(std,min,sek,tag,mon,jahr);                       (**)
(**)  writeln ('***    Zeit und Datum  /  Version 1.1    ***');            (**)
(**)  writeln ('(Bildschirm  ist   auf  weie   Schrift  mit');            (**)
(**)  writeln ('schwarzem     Grund     eingestellt.     Der');            (**)
(**)  writeln ('Zeilenberlauf ist aktiviert.)');                          (**)
(**)  writeln ('Entwickelt mit ST PASCAL PLUS von D. Rabich.');            (**)
(**)  writeln ('Zeit : ',std:2,':',min:2,':',sek:2);                       (**)
(**)  writeln ('Datum: ',tag:2,'.',mon:2,'.',1980+jahr:4);                 (**)
(**)  (* Hier ist das Datum der aktuellen TOS-Version eingefgt. *)        (**)
(**)  if (tag=6) and (mon=2) and (jahr=6) then                             (**)
(**)    begin                                                              (**)
(**)     repeat                                                            (**)
(**)      writeln ('Stellen Sie bitte Zeit und Datum ein!');               (**)
(**)      write ('Stunde [hh]:'); readln(std);                             (**)
(**)      write ('Minute [mm]:'); readln(min);                             (**)
(**)      write ('Tag    [tt]:'); readln(tag);                             (**)
(**)      write ('Monat  [mm]:'); readln(mon);                             (**)
(**)      write ('Jahr [jjjj]:'); readln(jahr);                            (**)
(**)      setze_zeit_und_datum(std,min,tag,mon,jahr);                      (**)
(**)      hole_zeit_und_datum(std,min,sek,tag,mon,jahr);                   (**)
(**)      writeln ('Neue Einstellung:');                                   (**)
(**)      writeln ('Zeit : ',std:2,':',min:2,':',sek:2);                   (**)
(**)      writeln ('Datum: ',tag:2,'.',mon:2,'.',1980+jahr:4);             (**)
(**)      writeln ('Bei falscher Eingabe bitte <RETURN> drcken.');        (**)
(**)     until conin(2)<>13;                                               (**)
(**)    end                                                                (**)
(**)   else                                                                (**)
(**)    writeln ('Zeit und Datum werden als korrekt angenommen.');         (**)
(**) end.                                                                  (**)
(**)                                                                       (**)
(*****************************************************************************)
(*****************************************************************************)

